'  ##################
' # primitives.inc #
'##################

' details
const _segments = 10
const _US# = (m_PI*2) / _segments
const _VS# =  m_PI    / _segments
const _NumOfPoints = (_segments + 1) * (_segments + 1)

dim _ListFloor
dim _ListSolidBox,_ListRGBBox,_ListShadowBox
dim _ListSphere  ,_ListShadowSphere
dim _ListCylinder,_ListShadowCylinder

dim _VA#(2),_VB#(2)
dim _PS#(_NumOfPoints*3-1)
dim _v(2),n(2),_i,_j
dim _UR#,_YP#,_VR#,_UW#,_VW#,_D#
dim _YC,_XC,_PC,_p0,_p1,_p2,_p3
dim _Lightpos#(3),_Plane#(3)
dim _FloorN#(2),_FloorQ#(3,2),_ShadowMat#(3,3)
dim Cam#(2)
'  ##############################################
' # Init OpenGL Light0 and build shadow matrix #
'##############################################
InitPrimitives:
glClearColor(0.2,0.2,0.8,1.0)
glEnable    (GL_LIGHTING)
glEnable    (GL_LIGHT0)
glEnable    (GL_COLOR_MATERIAL)
glCullFace  (GL_BACK)
glEnable    (GL_CULL_FACE)
Cam#=Vec3(0,5,25)
_FloorN#   =vec3( 0,1, 0)
_FloorQ#(0)=vec3(-100,0,-100)
_FloorQ#(1)=vec3(-100,0, 100)
_FloorQ#(2)=vec3( 100,0, 100)
_FloorQ#(3)=vec3( 100,0,-100)
_Lightpos# =vec4(0,150,-12,1)
glLightfv(GL_LIGHT0,GL_AMBIENT ,vec4(0.2,0.2,0.2,1.0))
glLightfv(GL_LIGHT0,GL_DIFFUSE ,vec4(1.0,0.6,0.8,1.0))
glLightfv(GL_LIGHT0,GL_SPECULAR,vec4(1.0,0.6,0.8,1.0))
_VA# = _FloorQ#(1)-_FloorQ#(0):Normalize(_VA#)
_VB# = _FloorQ#(2)-_FloorQ#(0):Normalize(_VB#)
_plane#(0) =   _VA#(1)*_VB#(2)-_VA#(2)*_VB#(1)
_plane#(1) = -(_VA#(0)*_VB#(2)-_VA#(2)*_VB#(0))
_plane#(2) =   _VA#(0)*_VB#(1)-_VA#(1)*_VB#(0)
_plane#(3) = -(_Plane#(0)*_FloorQ#(0,0)+_Plane#(1)*_FloorQ#(0,1)+_Plane#(2)*_FloorQ#(0,2))
_d#=_Plane#(0)*_LightPos#(0)+_Plane#(1)*_LightPos#(1)+_Plane#(1)*_LightPos#(2)+_Plane#(3)*_LightPos#(3)

_ShadowMat#(0,0)=_d# - _LightPos#(0) * _Plane#(0)
_ShadowMat#(1,0)=0.0 - _LightPos#(0) * _Plane#(1)
_ShadowMat#(2,0)=0.0 - _LightPos#(0) * _Plane#(2)
_ShadowMat#(3,0)=0.0 - _LightPos#(0) * _Plane#(3)

_ShadowMat#(0,1)=0.0 - _LightPos#(1) * _Plane#(0)
_ShadowMat#(1,1)=_d# - _LightPos#(1) * _Plane#(1)
_ShadowMat#(2,1)=0.0 - _LightPos#(1) * _Plane#(2)
_ShadowMat#(3,1)=0.0 - _LightPos#(1) * _Plane#(3)

_ShadowMat#(0,2)=0.0 - _LightPos#(2) * _Plane#(0)
_ShadowMat#(1,2)=0.0 - _LightPos#(2) * _Plane#(1)
_ShadowMat#(2,2)=_d# - _LightPos#(2) * _Plane#(2)
_ShadowMat#(3,2)=0.0 - _LightPos#(2) * _Plane#(3)

_ShadowMat#(0,3)=0.0 - _LightPos#(3) * _Plane#(0)
_ShadowMat#(1,3)=0.0 - _LightPos#(3) * _Plane#(1)
_ShadowMat#(2,3)=0.0 - _LightPos#(3) * _Plane#(2)
_ShadowMat#(3,3)=_d# - _LightPos#(3) * _Plane#(3)
goto _primitives_end_

EnableShadow:
  glDisable(GL_DEPTH_TEST)
  glDisable(GL_LIGHTING)
  glColor3f(0.2,0.1,0.0)
  glPushMatrix()
  glMultMatrixf(_ShadowMat#)
  return
  
DisableShadow:
  glPopMatrix()
  glEnable(GL_DEPTH_TEST)
  glEnable(GL_LIGHTING)
  return

DrawLight:
  glDisable(GL_LIGHTING)
  glPushMatrix()
    glLightfv(GL_LIGHT0,GL_POSITION,_LightPos#)
    glTranslatef(_LightPos#(0),_LightPos#(1)*0.5,_LightPos#(2)*10)
    glScalef(5,5,5)
    glColor3f(1,1,0.5)
    Gosub DrawSphere
  glPopMatrix()
  glEnable(GL_LIGHTING)
  return
  

DrawFloor:
  if _ListFloor=0 then
    _ListFloor=glGenLists(1)
    glNewList(_ListFloor,GL_COMPILE)
      glColor3f(0.5,0.25,0.1)
      glBegin(GL_QUADS)
        glNormal3fv(_FloorN#):glVertex3fv(_FloorQ#(0))
        glNormal3fv(_FloorN#):glVertex3fv(_FloorQ#(1))
        glNormal3fv(_FloorN#):glVertex3fv(_FloorQ#(2))
        glNormal3fv(_FloorN#):glVertex3fv(_FloorQ#(3))
      glEnd()
    glEndList()
  endif
  glCallList(_ListFloor)
  return


DrawSolidBox:
  if _ListSolidBox=0 then
    _ListSolidBox=glGenLists(1)
    glNewList(_ListSolidBox,GL_COMPILE)
      glBegin(GL_QUADS)
        glNormal3f(0,0,1)
        glVertex3f(-0.5, 0.5, 0.5):glVertex3f(-0.5,-0.5, 0.5)
        glVertex3f( 0.5,-0.5, 0.5):glVertex3f( 0.5, 0.5, 0.5)
        glNormal3f(1,0,0)
        glVertex3f( 0.5, 0.5, 0.5):glVertex3f( 0.5,-0.5, 0.5)
        glVertex3f( 0.5,-0.5,-0.5):glVertex3f( 0.5, 0.5,-0.5)
        glNormal3f  (0,0,-1)
        glVertex3f( 0.5, 0.5,-0.5):glVertex3f( 0.5,-0.5,-0.5)
        glVertex3f(-0.5,-0.5,-0.5):glVertex3f(-0.5, 0.5,-0.5)
        glNormal3f(-1,0,0)
        glVertex3f(-0.5, 0.5,-0.5):glVertex3f(-0.5,-0.5,-0.5)
        glVertex3f(-0.5,-0.5, 0.5):glVertex3f(-0.5, 0.5, 0.5)
        glNormal3f(0,1,0)
        glVertex3f(-0.5, 0.5,-0.5):glVertex3f(-0.5, 0.5, 0.5)
        glVertex3f( 0.5, 0.5, 0.5):glVertex3f( 0.5, 0.5,-0.5)
        glNormal3f(0,-1,0)
        glVertex3f(-0.5,-0.5, 0.5):glVertex3f(-0.5,-0.5,-0.5)
        glVertex3f( 0.5,-0.5,-0.5):glVertex3f( 0.5,-0.5, 0.5)
      glEnd()
    glEndList()
  endif
  glCallList(_ListSolidBox)
  return


DrawRGBBox:
  if _ListRGBBox=0 then
    _ListRGBBox=glGenLists(1)
    glNewList(_ListRGBBox,GL_COMPILE)
      glBegin(GL_QUADS)
        glNormal3f(0,0,1):glColor3F (1,0,0)
        glVertex3f(-0.5,  0.5,  0.5):glVertex3f(-0.5, -0.5,  0.5)
        glVertex3f( 0.5, -0.5,  0.5):glVertex3f( 0.5,  0.5,  0.5)
        glNormal3f(1,0,0):glColor3F (0,1,0)
        glVertex3f( 0.5,  0.5,  0.5):glVertex3f( 0.5, -0.5,  0.5)
        glVertex3f( 0.5, -0.5, -0.5):glVertex3f( 0.5,  0.5, -0.5)
        glNormal3f  (0,0,-1):glColor3F(0,0,1)
        glVertex3f( 0.5,  0.5, -0.5):glVertex3f( 0.5, -0.5, -0.5)
        glVertex3f(-0.5, -0.5, -0.5):glVertex3f(-0.5,  0.5, -0.5)
        glNormal3f(-1,0,0):glColor3F (1,1,0)
        glVertex3f(-0.5,  0.5, -0.5):glVertex3f(-0.5, -0.5, -0.5)
        glVertex3f(-0.5, -0.5,  0.5):glVertex3f(-0.5,  0.5,  0.5)
        glNormal3f(0,1,0):glColor3F(0,1,1)
        glVertex3f(-0.5,  0.5, -0.5):glVertex3f(-0.5,  0.5,  0.5)
        glVertex3f( 0.5,  0.5,  0.5):glVertex3f( 0.5,  0.5, -0.5)
        glNormal3f(0,-1,0):glColor3F (1,1,1)
        glVertex3f(-0.5, -0.5,  0.5):glVertex3f(-0.5, -0.5, -0.5)
        glVertex3f( 0.5, -0.5, -0.5):glVertex3f( 0.5, -0.5,  0.5)
      glEnd()
    glEndList()
  endif
  glCallList(_ListRGBBox)
  return

DrawShadowBox:
  if _ListShadowBox=0 then
    _ListShadowBox=glGenLists(1)
    glNewList(_ListShadowBox,GL_COMPILE)
      glBegin(GL_QUADS)
        glVertex3f(-0.5,  0.5,  0.5):glVertex3f(-0.5, -0.5,  0.5)
        glVertex3f( 0.5, -0.5,  0.5):glVertex3f( 0.5,  0.5,  0.5)
        glVertex3f( 0.5,  0.5,  0.5):glVertex3f( 0.5, -0.5,  0.5)
        glVertex3f( 0.5, -0.5, -0.5):glVertex3f( 0.5,  0.5, -0.5)
        glVertex3f( 0.5,  0.5, -0.5):glVertex3f( 0.5, -0.5, -0.5)
        glVertex3f(-0.5, -0.5, -0.5):glVertex3f(-0.5,  0.5, -0.5)
        glVertex3f(-0.5,  0.5, -0.5):glVertex3f(-0.5, -0.5, -0.5)
        glVertex3f(-0.5, -0.5,  0.5):glVertex3f(-0.5,  0.5,  0.5)
        glVertex3f(-0.5,  0.5, -0.5):glVertex3f(-0.5,  0.5,  0.5)
        glVertex3f( 0.5,  0.5,  0.5):glVertex3f( 0.5,  0.5, -0.5)
        glVertex3f(-0.5, -0.5,  0.5):glVertex3f(-0.5, -0.5, -0.5)
        glVertex3f( 0.5, -0.5, -0.5):glVertex3f( 0.5, -0.5,  0.5)
      glEnd()
    glEndList()
  endif
  glCallList(_ListShadowBox)
  return

DrawSphere:
  if _ListSphere=0 then
    _VW#=0:_UW#=0:_PC=0
    For _yc = 0 To _segments
      _UR# = Sin(_VW#) '* 0.5
      _YP# = Cos(_VW#) '* 0.5
      _VR# = Sin(_VW#) '* 0.5
      _VW# =_VW#+_VS#
          
      _UW# = 0
      For _xc = 0 To _segments
        _PS#(_PC*3+0)=Sin(     _UW#) * _UR#
        _PS#(_PC*3+1)=_YP#
        _PS#(_PC*3+2)=Cos(m_PI+_UW#) * _VR#
        _PC=_PC+1: _UW#=_UW#+_US#
      Next
    Next
    _ListSphere=glGenLists(1)
    glNewList (_ListSphere, GL_COMPILE)
    glBegin (GL_TRIANGLES)
      For _yc= 0 To _segments - 1
        For _xc= 0 To _segments - 1
          _P0 = (_yc + 0) * (_segments + 1) + (_xc + 0)
          _P1 = (_yc + 0) * (_segments + 1) + (_xc + 1)
          _P2 = (_yc + 1) * (_segments + 1) + (_xc + 1)
          _P3 = (_yc + 1) * (_segments + 1) + (_xc + 0)
          _VA#=Vec3(_PS#(_p0*3+0),_PS#(_p0*3+1),_PS#(_p0*3+2))
          glNormal3fv(Normalize(_VA#)):glVertex3fv(_VA#)
          _VA#=Vec3(_PS#(_p1*3+0),_PS#(_p1*3+1),_PS#(_p1*3+2))
          glNormal3fv(Normalize(_VA#)):glVertex3fv(_VA#)
          _VA#=Vec3(_PS#(_p3*3+0),_PS#(_p3*3+1),_PS#(_p3*3+2))
          glNormal3fv(Normalize(_VA#)):glVertex3fv(_VA#)
          _VA#=Vec3(_PS#(_p1*3+0),_PS#(_p1*3+1),_PS#(_p1*3+2))
          glNormal3fv(Normalize(_VA#)):glVertex3fv(_VA#)
          _VA#=Vec3(_PS#(_p2*3+0),_PS#(_p2*3+1),_PS#(_p2*3+2))
          glNormal3fv(Normalize(_VA#)):glVertex3fv(_VA#)
          _VA#=Vec3(_PS#(_p3*3+0),_PS#(_p3*3+1),_PS#(_p3*3+2))
          glNormal3fv(Normalize(_VA#)):glVertex3fv(_VA#)
        Next
      Next
    glEnd()
    glEndList()
  end if
  ' draw the compiled sphere
  glCallList(_ListSphere)
  return                               

DrawShadowSphere:
  if _ListShadowSphere=0 then
    _VW#=0:_UW#=0:_PC=0
    For _yc = 0 To _segments
      _UR# = Sin(_VW#) '* 0.5
      _YP# = Cos(_VW#) '* 0.5
      _VR# = Sin(_VW#) '* 0.5
      _VW# =_VW#+_VS#
          
      _UW# = 0
      For _xc = 0 To _segments
        _PS#(_PC*3+0)=Sin(     _UW#) * _UR#
        _PS#(_PC*3+1)=_YP#
        _PS#(_PC*3+2)=Cos(m_PI+_UW#) * _VR#
        _PC=_PC+1: _UW#=_UW#+_US#
      Next
    Next
    _ListShadowSphere=glGenLists(1)
    glNewList (_ListShadowSphere, GL_COMPILE)
    glBegin (GL_TRIANGLES)
      For _yc= 0 To _segments - 1
        For _xc= 0 To _segments - 1
          _P0 = (_yc + 0) * (_segments + 1) + (_xc + 0)
          _P1 = (_yc + 0) * (_segments + 1) + (_xc + 1)
          _P2 = (_yc + 1) * (_segments + 1) + (_xc + 1)
          _P3 = (_yc + 1) * (_segments + 1) + (_xc + 0)
          glVertex3fv(Vec3(_PS#(_p0*3+0),_PS#(_p0*3+1),_PS#(_p0*3+2)))
          glVertex3fv(Vec3(_PS#(_p1*3+0),_PS#(_p1*3+1),_PS#(_p1*3+2)))
          glVertex3fv(Vec3(_PS#(_p3*3+0),_PS#(_p3*3+1),_PS#(_p3*3+2)))
          glVertex3fv(Vec3(_PS#(_p1*3+0),_PS#(_p1*3+1),_PS#(_p1*3+2)))
          glVertex3fv(Vec3(_PS#(_p2*3+0),_PS#(_p2*3+1),_PS#(_p2*3+2)))
          glVertex3fv(Vec3(_PS#(_p3*3+0),_PS#(_p3*3+1),_PS#(_p3*3+2)))
        Next
      Next
    glEnd()
    glEndList()
  end if
  glCallList(_ListShadowSphere)
  return                               




DrawCylinder:
'   ##########################################
'  # draw a unit Cylynder length=1:radius=1 #
' ########################################## 
  ' compile it only once
  if _ListCylinder=0 then
    _UW#=0
    for _i=0 to _segments
      _PS#(_i*2+0)=cos(_UW#)*0.5 ' x
      _PS#(_i*2+1)=sin(_UW#)*0.5 ' y
      _UW#=_UW#+_US#
    next
    _ListCylinder=glGenLists(1)
    glNewList (_ListCylinder, GL_COMPILE)
      glBegin(GL_TRIANGLE_FAN)
        glNormal3f(0,0,1):glVertex3fv(Vec3(0,0,0.5)) ' center
        for _i=0 to _segments 
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1), 0.5))
        next
      glEnd()
      glBegin(GL_TRIANGLE_FAN)
        glNormal3f(0,0,-1):glVertex3fv(Vec3(0,0,-0.5)) ' center
        for _i=_segments to 0 step -1
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1),-0.5))
        next
      glEnd()
      glBegin(GL_TRIANGLE_STRIP)
        for _i=_segments to 0 step -1
            _j=_i+1 :_j=_j % _segments
          _VA#=Normalize(vec3(_PS#(_j*2+0),_PS#(_j*2+1),-0.5)-vec3(_PS#(_i*2+0),_PS#(_i*2+1),-0.5))
          _VB#=Normalize(vec3(_PS#(_i*2+0),_PS#(_i*2+1), 0.5)-vec3(_PS#(_i*2+0),_PS#(_i*2+1),-0.5))
          glNormal3fv(Crossproduct(_VA#,_VB#))
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1),-0.5))
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1),0.5))
        next
      glEnd()
    glEndList()
  end if
  ' draw the compiled cylinder
  glCallList(_ListCylinder)
  return

DrawShadowCylinder:
  if _ListShadowCylinder=0 then
    _UW#=0
    for _i=0 to _segments
      _PS#(_i*2+0)=cos(_UW#)*0.5 ' x
      _PS#(_i*2+1)=sin(_UW#)*0.5 ' y
      _UW#=_UW#+_US#
    next
    _ListShadowCylinder=glGenLists(1)
    glNewList (_ListShadowCylinder, GL_COMPILE)
      glBegin(GL_TRIANGLE_FAN)
        glVertex3fv(Vec3(0,0,0.5)) ' center
        for _i=0 to _segments 
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1), 0.5))
        next
      glEnd()
      glBegin(GL_TRIANGLE_FAN)
        glVertex3fv(Vec3(0,0,-0.5)) ' center
        for _i=_segments to 0 step -1
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1),-0.5))
        next
      glEnd()
      glBegin(GL_TRIANGLE_STRIP)
        for _i=_segments to 0 step -1
            _j=(_i+1) % _segments
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1),-0.5))
          glVertex3fv(Vec3(_PS#(_i*2+0),_PS#(_i*2+1),0.5))
        next
      glEnd()
    glEndList()
  end if
  glCallList(_ListShadowCylinder)
  return
 
_primitives_end_: